class venkymullapudi_winbind::configs inherits venkymullapudi_winbind {

 augeas {
  "nsswitch":
  context => "/files/etc/nsswitch.conf",
  changes => [
    "set *[self::database = 'hosts']/service[2] dns",
    "set *[self::database = 'passwd']/service[2] winbind",
    "set *[self::database = 'group']/service[2] winbind",
    "set *[self::database = 'shadow']/service[2] winbind",
    ],

                
} 

-> augeas { "resolv":
  context => "/files/etc/resolv.conf",
  changes => [
              "set domain ${domain}",
              "set search ${domain}",
               "set nameserver '$dnsipaddr'",
],
  onlyif  => ["match nameserver[. = '$dnsipaddr'] size == 0",
              "match domain [. = '${domain}'] size == 0",
              "match search [. = '${domain}'] size == 0",
],


} -> augeas { "hosts":
  context => "/files/etc/hosts",
  changes => [
    "set 01/ipaddr $adipaddr",
    "set 01/canonical $adserver",
    "set 01/alias[1] $kdc",
],
  onlyif => [
    "match *[ipaddr = '$adipaddr'] size == 0",
]

} -> augeas {"krb5":
  context => "/files/etc/krb5.conf",
  changes => [
      "set libdefaults/default_realm '$realmcaps'",
      "set libdefaults/dns_lookup_realm true",
      "set libdefaults/dns_lookup_kdc true",
      "set libdefaults/ticket_lifetime 24h",
      "set libdefaults/forwardable yes",
      "set libdefaults/debug false",
      "set realms/realm $realmcaps",
      "set realms/realm/kdc[1] $kdc:88",
      "set realms/realm/kdc[2] $kdccaps:88",
      "set realms/realm/admin_server $kdc:749",
      "set realms/realm/default_domain $domain ",
      "set domain_realm/.test.com $domaincaps",
      "set domain_realm/test.com $domaincaps",
      "set appdefaults/forwardable true",
      "set appdefaults/application pam",
      "set appdefaults/application/debug false",
],
} 

#exec {"kdestroy":
#    path => [ "/bin/", "/usr/bin" ]
#    }


-> exec { "echo \"${adpasswd}\" | kinit ${aduser}@${realmcaps}":
    #unless => "klist",
    path => [ "/bin/", "/usr/bin" ]
    }



-> augeas { "pam1":
  context => "/files/etc/pam.d",
  changes => [
      "ins 01 after system-auth/*[type='auth'][module='pam_succeed_if.so']",
      "set system-auth/01/type auth",
      "set system-auth/01/control sufficient",
      "set system-auth/01/module pam_winbind.so",
      "set system-auth/01/argument[1] use_first_pass",
],
 onlyif => "match system-auth/*[type='auth'][module='pam_winbind.so'] size == 0";

  "pam2":
  context => "/files/etc/pam.d",
  changes => [

      "ins 02 after system-auth/*[type='auth'][module='pam_deny.so']",
      "set system-auth/02/type account",
      "set system-auth/02/control sufficient",
      "set system-auth/02/module pam_ldap.so",
],
onlyif => "match system-auth/*[type='auth'][module='pam_ldap.so'] size == 0";

  "pam3":
  context => "/files/etc/pam.d",
  changes => [

      "ins 03 after system-auth/*[type='account'][module='pam_succeed_if.so']",
      "set system-auth/03/type account",
      "set system-auth/03/control '[default=bad success=ok user_unknown=ignore]'",
      "set system-auth/03/module pam_winbind.so",
],
onlyif => "match system-auth/*[type='account'][module='pam_winbind.so'] size == 0";

  "pam4":
  context => "/files/etc/pam.d",
  changes => [
      "ins 04 after system-auth/*[type='password'][module='pam_unix.so']",
      "set system-auth/04/type password",
      "set system-auth/04/control sufficient",
      "set system-auth/04/module pam_winbind.so",
      "set system-auth/04/argument[1] use_authtok",
],
onlyif => "match system-auth/*[type='password'][module='pam_winbind.so'] size == 0";

  "pam5":
  context => "/files/etc/pam.d",
  changes => [

      "ins 05 after system-auth/*[type='session'][module='pam_unix.so']",
      "set system-auth/05/type session",
      "set system-auth/05/control required",
      "set system-auth/05/module pam_mkhomedir.so",
      "set system-auth/05/argument[1] skel=etc/skel",
      "set system-auth/05/argument[2] umask=0027",
],
 onlyif => "match system-auth/*[type='session'][module='pam_mkhomedir.so'] size == 0";
}


# Section of smb.conf

-> exec { "authconfig --update --kickstart --enablewinbind --enablewinbindauth --disableldapauth --smbworkgroup=${workgroup} --smbservers=${kdc} --smbrealm=${realmcaps} --smbsecurity=ads --winbindtemplatehomedir=/home/%U --winbindtemplateshell=/bin/bash --enablewinbindusedefaultdomain --enablelocauthorize --enablemd5":
   path => [ "/bin/", "/usr/sbin" ]
   }

-> exec { "net join -S $adsrvrcaps -U ${aduser}%$adpasswd":
    unless => "net ads testjoin",
    path => [ "/bin/", "/usr/bin" ]
    }

}

